<template>
  <div
    v-if="order.orderStatus === STEP.ALLOCATED && isMainOrder"
    class="account-sign"
  >
    <div class="account-order__title">
      Подписание заявки
    </div>

    <ObControlGroup
      :value="currentSignType"
      :items="signTypes"
      theme="light"
      data-qa="changeSignType"
      @input="onChangeSignType"
      height="slim"
    />

    <div
      v-if="isAutoSign"
    >
      <div class="account-sign__text">Заявка будет автоматически подписана</div>

      <button
        data-qa="btnDownloadTemplate"
        class="btn-template"
        @click="download"
      >
        <span
          v-if="!isTemplateLoading"
        >
          <i class="icon download" />
          <span>Скачать заявку </span>
        </span>
        <span
          v-else
          class="btn-template__loader"
        >
          <ObLoader
            :size="14"
          />
        </span>
      </button>
    </div>
    <div
      v-if="isManualSign"
    >
      <div class="account-sign__text">1. Скачайте</div>
      <button
        data-qa="btnDownloadTemplate"
        class="btn-template"
        @click="downloadTemplate"
      >
        <span
          v-if="!isTemplateLoading"
        >
          <i class="icon download" />
          <span>Скачать заявку к подписанию</span>
        </span>
        <span
          v-else
          class="btn-template__loader"
        >
          <ObLoader
            :size="14"
          />
        </span>
      </button>
      <div class="account-sign__text mt20">2. Загрузите подписанное</div>
      <ObUploader
        @change="onUploadHandler"
        ref="uploader"
      />
    </div>
    <div class="sign-button__container">
      <ObButton
        @click="requestExecution"
        :label="signButtonLabel"
        :disabled="isSignButtonDisabled"
        class="sign-button"
      />
    </div>
  </div>
</template>
<script>
import ObLoader from "common-components/src/obComponents/obLoader"
import ObUploader from 'common-components/src/obComponents/obUploader'
import ObButton from "common-components/src/obComponents/obButton"
import ObControlGroup from 'common-components/src/obComponents/obControlGroup'
import STEPS from '@/constants/steps.js'
import api from '@/api'
import { mapGetters, mapActions } from 'vuex'

const signTypes = {
  AUTO: 'AUTO',
  MANUAL: 'MANUAL'
}

export default {
  components: {
    ObLoader,
    ObButton,
    ObControlGroup,
    ObUploader
  },
  data () {
    return {
      STEP: STEPS,
      loaderFile: false,
      currentSignType: signTypes.AUTO,
      isTemplateLoading: false,
      isDownload: false,
      facsimile: {
        fileUuid:'',
        file:'',
        loader: false,
        isShow: false,
        canBeSigned: false,
        filename: ""
      },
    }
  },
  mounted () {
    this.getFacsimile()
  },
  computed: {
    ...mapGetters({
      order: 'account/order',
      canSubmitDoc:  'account/canSubmitDoc',
      buttonSignResource:  'account/buttonSignResource',
      statementUuid: 'account/statementUuid',
      contractorUuid: 'user/participantUuid'
    }),
    isMainOrder () {
      return this.contractorUuid === this.order?.contractorUuid
    },
    signTypes () {
      return [
        {
          label: 'Автоматически',
          value: signTypes.AUTO
        },
        {
          label: 'Вручную',
          value: signTypes.MANUAL
        }
      ]
    },
    isAutoSign () {
      return this.currentSignType === signTypes.AUTO
    },
    isManualSign () {
      return this.currentSignType === signTypes.MANUAL
    },
    signButtonLabel () {
      if (this.isAutoSign) {
        return 'Подписать заявку автоматически'
      } else {
        return 'Отправить загруженную заявку'
      }
    },
    isSignButtonDisabled () {
      return this.buttonSignResource || (!this.isAutoSign && !this.statementUuid)
    }
  },
  methods: {
    ...mapActions({
      setStatement: 'account/setStatement',
      setDisabledSignResource: 'account/setDisabledSignResource',
      requestExecution: 'account/requestExecution'
    }),
    onChangeSignType (type) {
      this.$refs.uploader?.clearFiles()
      this.setStatement(null)
      this.currentSignType = type
    },
    async downloadTemplate () {
      try {
        this.isTemplateLoading = true
        await api.orderProcess.getOrderRequestTemplate({ uuid: this.order.suborderUuid })
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки файла'
        })
      } finally {
        this.isDownload = true
        this.isTemplateLoading = false
      }
    },
    async onUploadHandler (data) {
      data = data[0]
      if (!data) {
        this.setStatement(null)
        return
      }

      try {
        await api.files.postFile({ uuid: data.uuid, file: data.file })
        this.setStatement(data.uuid)
      } catch (e) {
        console.log(e)
      }
    },
    async getFacsimile () {
      await api.accountOrder.getFacsimile(this.order.suborderUuid).then(res => {
        this.facsimile.canBeSigned = res.data.canBeSigned
        this.facsimile.filename = res.data.filename
      })
    },
    async download () {
      this.isTemplateLoading = true

      try {
        await api.accountOrder.getFacsimileFile(this.order.suborderUuid, this.facsimile.filename)
      } catch (e) {
        console.log(e)
      } finally {
        this.isTemplateLoading = false
      }
    },
    click (){
      if (this.facsimile.isShow) {
        this.setStatement('facsimile')
      } else {
        this.setStatement('')
      }
    }
  }
}
</script>
<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";
.account-sign {
  padding: 10px 0 20px 0;
  &::v-deep {
    .ob-ctrlgroup {
      width: 100%;
      margin: 20px 0;
      height: 30px;
      .ob-ctrlgroup__content {
        width: 100%;
      }
      .ob-ctrlgroup__item {
        flex-grow: 2;
      }
    }
    .ob-uploader {
      margin-bottom: 30px;
    }
  }
  .mt20 {
    margin-top: 20px !important;
  }
  .account-sign__text {
    margin-bottom: 10px;
    @include font-mixin(14px, 18px, 400);
  }
  .btn-template {
    display: flex;
    align-items: center;
    margin-left: -3px;
    border: none;
    background-color: transparent;
    outline: none;
    cursor: pointer;
    @include font-mixin(14px, 18px, 400, $color-blue-navy-blue);
    span {
      display: flex;
      align-items: center;
    }
    .icon {
      margin-right: 4px;
    }
    &:hover {
      opacity: 0.8;
    }
  }
  .btn-template {
    &__loader {
      width: 120px;
      display: flex;
      justify-content: center;
    }
  }
  .sign-button {
    &__container {
      margin-top: 20px;
      display: flex;
      justify-content: center;
    }
  }
  .fadeIn-enter,
  .fadeIn-leave-to {
    opacity: 0;
  }

  .fadeIn-enter-active,
  .fadeIn-leave-active {
    transition: opacity .3s ease-in-out;
  }
}
</style>
